package com.persagy.calendar.pojo.dto;

import com.baomidou.mybatisplus.annotation.FieldStrategy;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.conditions.update.UpdateWrapper;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import com.persagy.common.utils.StringUtil;

import lombok.EqualsAndHashCode;
import lombok.Getter;
import lombok.Setter;
import lombok.ToString;

/**
 * @version
 * @description
 * @company persagy
 * @author zhangqiankun
 * @since 2021年3月3日: 下午7:49:44
 */
@Getter
@Setter
@ToString
@EqualsAndHashCode(callSuper = false)
@TableName("work_calendar_dict")
public class WorkCalendarDict extends Model<WorkCalendarDict> {
	private static final long serialVersionUID = -4969298760644522850L;

	@TableField(updateStrategy = FieldStrategy.NOT_EMPTY)
	private String groupCode; 	// 集团编码

	@TableField(updateStrategy = FieldStrategy.NOT_EMPTY)
	private String calendarId; // 工作历ID
	
	@TableField(updateStrategy = FieldStrategy.NOT_EMPTY)
	private String dictType; // 字典类型

	@TableField(updateStrategy = FieldStrategy.NOT_EMPTY)
	private String dictCode; // 字典数据的code

	@TableField(updateStrategy = FieldStrategy.NOT_EMPTY)
	private String dictDesc; // 字典类型的描述
	
	public static class Builder {

		private QueryWrapper<WorkCalendarDict> queryWrapper = null;

		private UpdateWrapper<WorkCalendarDict> updateWrapper = null;

		public Builder createQueryWrapper() {
			queryWrapper = new QueryWrapper<WorkCalendarDict>();
			return this;
		}

		public Builder createUpdateWrapper() {
			updateWrapper = new UpdateWrapper<WorkCalendarDict>();
			return this;
		}

		public Builder groupCodeEq(String groupCode) {
			if (StringUtil.isNotBlank(groupCode)) {
				if (updateWrapper != null) {
					updateWrapper.eq("GROUP_CODE", groupCode);
				} else {
					queryWrapper.eq("GROUP_CODE", groupCode);
				}
			}
			return this;
		}

		public Builder calendarIdEq(String calendarId) {
			if (StringUtil.isNotBlank(calendarId)) {
				if (updateWrapper != null) {
					updateWrapper.eq("CALENDAR_ID", calendarId);
				} else {
					queryWrapper.eq("CALENDAR_ID", calendarId);
				}
			}
			return this;
		}
		
		public Builder dictTypeEq(String dictType) {
			if (StringUtil.isNotBlank(dictType)) {
				if (updateWrapper != null) {
					updateWrapper.eq("DICT_TYPE", dictType);
				} else {
					queryWrapper.eq("DICT_TYPE", dictType);
				}
			}
			return this;
		}

		public Builder dictCodeEq(String dictCode) {
			if (StringUtil.isNotBlank(dictCode)) {
				if (updateWrapper != null) {
					updateWrapper.eq("DICT_CODE", dictCode);
				} else {
					queryWrapper.eq("DICT_CODE", dictCode);
				}
			}
			return this;
		}
		
		public QueryWrapper<WorkCalendarDict> builderQueryWrapper() {
			return queryWrapper;
		}

		public UpdateWrapper<WorkCalendarDict> builderUpdateWrapper() {
			return updateWrapper;
		}
	}
}
